﻿Option Explicit On

Public Class FrmFileNew

  '**************************************************
  ' フォーム
  '**************************************************
  '**************************************************
  ' ロード
  Private Sub FrmFileNew_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    Me.TextBoxWidth.Text = My.Settings.CanvasWidth
    Me.TextBoxHeight.Text = My.Settings.CanvasHeight

    '入力できる桁数は、4桁までとする
    Me.TextBoxWidth.MaxLength = 4
    Me.TextBoxHeight.MaxLength = 4

  End Sub
  '**************************************************
  ' ボタン
  '**************************************************
  '**************************************************
  ' OK
  Private Sub ButtonOk_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOk.Click

    If Not IsNumeric(Me.TextBoxWidth.Text) Then
      MessageBox.Show("幅には数値を入力して下さい", "入力エラー", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
      Me.TextBoxWidth.Focus()
      Me.TextBoxWidth.SelectAll()
      Exit Sub
    End If
    If Integer.Parse(Me.TextBoxWidth.Text) > 2000 Then
      MessageBox.Show("幅には2000ドットまでの値を入力して下さい", "入力エラー", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
      Me.TextBoxWidth.Focus()
      Me.TextBoxWidth.SelectAll()
      Exit Sub
    End If

    If Not IsNumeric(Me.TextBoxHeight.Text) Then
      MessageBox.Show("高さには数値を入力して下さい", "入力エラー", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
      Me.TextBoxHeight.Focus()
      Me.TextBoxHeight.SelectAll()
      Exit Sub
    End If
    If Integer.Parse(Me.TextBoxHeight.Text) > 2000 Then
      MessageBox.Show("高さには2000ドットまでの値を入力して下さい", "入力エラー", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
      Me.TextBoxHeight.Focus()
      Me.TextBoxHeight.SelectAll()
      Exit Sub
    End If

    My.Settings.CanvasWidth = Integer.Parse(Me.TextBoxWidth.Text)
    My.Settings.CanvasHeight = Integer.Parse(Me.TextBoxHeight.Text)

    'ピクチャーボックスの大きさを設定
    PictureBoxSizeSet()

    'レイヤーの情報を削除
    LayerAllDel()

    gLayerNum = 0
    LayerAdd()         '最初のレイヤーを作成
    gSelectLayerNo = 1 '最初のレイヤーを選択
    LayerSelectColor(gSelectLayerNo)

    gProjectName = NON_TITLE 'プロジェクト名
    gUpdFlg = False

    'タイトルバーの表示
    FrmMikapen.Text = Application.ProductName & " (" & gProjectName & " " & My.Settings.CanvasWidth & " x " & My.Settings.CanvasHeight & ")"

    Me.Dispose()

  End Sub
  '**************************************************
  ' キャンセル
  Private Sub ButtonCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCancel.Click

    Me.Dispose()

  End Sub

End Class