﻿'**************************************************
'
' 簡易ペイントソフト ミカペン
' 再配布の際は、ソリューション エクスプローラ メニューのMikapenのプロパティより、アプリケーションタブ、アセンブリ情報の内容を修正してください
'
' 修正内容
'
' 090 初期公開版
'     自動生成された関数の、As Object を As System.Object に修正
' 091 不具合修正版
'     プラットフォームを、Any CPUに変更
'     Graphicsや、Bitmapを使った後のDisposeが抜けていたのを追加
'     ピクチャーボックスのサイズのリセット機能を追加
' 092 コメントの修正など軽微な修正
'     メニューのショートカットキーが重複していたのを修正
' 093 メニューの終了で、SaveCheck()が呼ばれていたので、保存の確認が二重になっていたのを修正
'     MouseDown処理の、ペンやブラシが選択されていないときは抜ける判断をまとめた
' 094 ホームページのアドレスを変更
' 095 透過の指定を追加
'     プロジェクトの保存、上書きの保存部分の修正
' 096 FileDialogからファイルを選ぶときなど、ルート以外は末尾に\が付かないので、判断後に一律付加するように修正
'
'**************************************************
Option Explicit On

Public Class FrmMikapen

  '**************************************************
  ' フォーム
  '**************************************************
  '**************************************************
  ' ロード
  Private Sub FrmMikapen_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    Me.Text = Application.ProductName
    Me.MinimumSize = New Size(650, 520)
    Me.Size = My.Settings.Size

    '表示位置が画面からはみ出すときは、位置調整する
    If Me.Top < System.Windows.Forms.Screen.GetWorkingArea(Me).Top Or Me.Top >= System.Windows.Forms.Screen.GetWorkingArea(Me).Bottom Then
      Me.Top = 100
    End If
    If Me.Left < System.Windows.Forms.Screen.GetWorkingArea(Me).Left Or Me.Left >= System.Windows.Forms.Screen.GetWorkingArea(Me).Right Then
      Me.Left = 100
    End If

    'ヘルプファイルのパスの設定
    gHelpFilePath = System.IO.Path.GetDirectoryName(Application.ExecutablePath)
    If Not gHelpFilePath.EndsWith("\") Then
      gHelpFilePath &= "\"
    End If
    gHelpFilePath &= HELP_FILENAME

    'キャンバスの大きさ設定(初期値0のときは、スクリーンの大きさとする)
    If My.Settings.CanvasWidth = 0 Then
      My.Settings.CanvasWidth = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width
    End If
    If My.Settings.CanvasHeight = 0 Then
      My.Settings.CanvasHeight = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height
    End If

    'ピクチャーボックスの大きさを設定
    PictureBoxSizeSet()

    '各ピクチャーボックスの属性を設定
    Me.PictureBoxTop.BackColor = Color.Transparent
    Me.PictureBoxTop.Parent = Me.PictureBoxLayerFront

    Me.PictureBoxLayerFront.BackColor = Color.Transparent
    Me.PictureBoxLayerFront.Parent = Me.PictureBoxDraw

    Me.PictureBoxDraw.BackColor = Color.Transparent
    Me.PictureBoxDraw.Parent = Me.PictureBoxWork

    Me.PictureBoxWork.BackColor = Color.Transparent
    Me.PictureBoxWork.Parent = Me.PictureBoxLayerBack

    Me.PictureBoxLayerBack.BackColor = Color.Transparent

    'RGB(255.255.255)は、ビットマップの透過色として使用するので、
    'ミカペンでの白は、RGB(255.254.255)とする、255.254.255に特に意味はありません、緑から1を引いただけです
    Me.LabelColor6.BackColor = System.Drawing.ColorTranslator.FromOle(RGB(255, 255 - 1, 255))
    'カラーパレット設定
    gPenWidth = 1 'ペンの幅のデフォルト
    gPenTrans = 255 'ペンの透過率のデフォルト (Alphaの引数に使うので、0:透明、255:不透明)
    gColorLeft = Me.LabelColor1.BackColor
    gColorRight = Me.LabelColor6.BackColor
    gColorErase = Color.FromArgb(0, Color.Transparent)
    Me.LabelMouseLeft.BackColor = gColorLeft
    Me.LabelMouseRight.BackColor = gColorRight
    ColorSet()

    gMouseBaseX = -1 'マウス位置の初期化
    gMouseBaseY = -1 'マウス位置の初期化
    gMouseFromX = -1 'マウス位置の初期化
    gMouseFromY = -1 'マウス位置の初期化

    'レイヤーの設定
    '動的に作成するレイヤーの情報の、ベースとなるコントロールを不可視にする
    Me.PanelLayer.Visible = False
    Me.PictureBoxLayer.Visible = False
    Me.TextBoxLayerName.Visible = False

    gLayerNum = 0
    LayerAdd()         '最初のレイヤーを作成
    gSelectLayerNo = 1 '最初のレイヤーを選択
    LayerSelectColor(gSelectLayerNo)

    '線幅トラックバーの設定
    Me.TrackBarLineWidth.Minimum = 1   '最小値は1
    Me.TrackBarLineWidth.Maximum = 256 '最大値は256
    gPenWidth = 1
    Me.TrackBarLineWidth.Value = gPenWidth 'ペン幅1の位置にカーソル移動
    Me.LabelWidthText.Text = "線幅:" & gPenWidth

    '透過トラックバーの設定
    Me.TrackBarLineTrans.Minimum = 0   '最小値は0 (Alphaの引数に使うので透明)
    Me.TrackBarLineTrans.Maximum = 255 '最大値は255 (透過しない)
    gPenTrans = 255
    Me.TrackBarLineTrans.Value = gPenTrans 'ペン透過0の位置にカーソル移動
    Me.LabelTransText.Text = "透過:" & gPenTrans

    'ステータスバー初期化
    Me.ToolStripStatusLabelPos.Text = "位置"
    Me.ToolStripStatusLabelOffset.Text = "範囲"

    '描画モード
    Me.RadioButtonPencil.Select() 'エンピツを初期値

    gProjectName = NON_TITLE 'プロジェクト名
    gUpdFlg = False

    'タイトルバーの表示
    Me.Text = Application.ProductName & " (" & gProjectName & " " & My.Settings.CanvasWidth & " x " & My.Settings.CanvasHeight & ")"

  End Sub
  '**************************************************
  ' リサイズ
  ' 最大化されたときの判断用
  Private Sub FrmMikapen_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Me.Resize

    If (Me.WindowState = FormWindowState.Maximized) Or (Me.WindowState = FormWindowState.Normal) Then
      'パーツパネルの位置変更
      Me.PanelParts.Location = New Point(Me.ClientSize.Width - Me.PanelParts.Width, 0)
      'ピクチャーパネルの位置とサイズ変更
      Me.PanelPictureBack.Location = New Point(0, 0)
      Me.PanelPictureBack.Size = New Size(Me.ClientSize.Width - Me.PanelParts.Width, Me.ClientSize.Height - Me.MenuStrip.ClientSize.Height - Me.StatusStrip.ClientSize.Height)
    End If

  End Sub
  '**************************************************
  ' クローズ
  Private Sub FrmMikapen_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing

    '保存の判定を行う
    If SaveCheck() = True Then
      CloseRtn()
    Else
      e.Cancel = True
    End If

  End Sub
  '**************************************************
  ' ボタン
  '**************************************************
  '**************************************************
  ' レイヤーの追加
  Private Sub ButtonLayerAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLayerAdd.Click

    gUpdFlg = True '更新あり

    LayerAdd()

  End Sub
  '**************************************************
  ' レイヤーの削除
  Private Sub ButtonLayerDel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLayerDel.Click

    gUpdFlg = True '更新あり

    LayerDell()
    LayerWorkSet()

  End Sub
  '**************************************************
  ' レイヤーの上移動
  Private Sub ButtonLayerUp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLayerUp.Click

    gUpdFlg = True '更新あり

    '直前の描画を、反映させる
    gGraphicsWork.DrawImage(PictureBoxDraw.Image, New Rectangle(New Point(0, 0), gBitmapDraw.Size), 0, 0, gBitmapDraw.Width, gBitmapDraw.Height, GraphicsUnit.Pixel)
    gGraphicsDraw.Clear(Color.Transparent)
    Me.PictureBoxDraw.Invalidate()

    LayerUp()
    LayerWorkSet()

  End Sub
  '**************************************************
  ' レイヤーの下移動
  Private Sub ButtonLayerDown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLayerDown.Click

    gUpdFlg = True '更新あり

    '直前の描画を、反映させる
    gGraphicsWork.DrawImage(PictureBoxDraw.Image, New Rectangle(New Point(0, 0), gBitmapDraw.Size), 0, 0, gBitmapDraw.Width, gBitmapDraw.Height, GraphicsUnit.Pixel)
    gGraphicsDraw.Clear(Color.Transparent)
    Me.PictureBoxDraw.Invalidate()

    LayerDown()
    LayerWorkSet()

  End Sub
  '**************************************************
  ' ラジオボタン
  '**************************************************
  '**************************************************
  ' エンピツ
  Private Sub RadioButtonPencil_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonPencil.CheckedChanged

    gDrawMode = DrawMode.modePencil

  End Sub
  '**************************************************
  ' 消しゴム
  Private Sub RadioButtonEraser_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonEraser.CheckedChanged

    gDrawMode = DrawMode.modeEraser

  End Sub
  '**************************************************
  ' やり直し
  Private Sub RadioButtonUnDo_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonUnDo.CheckedChanged
    Dim mGraphics As Graphics

    gGraphicsDraw.Clear(Color.Transparent)
    Me.PictureBoxDraw.Invalidate()

    mGraphics = Graphics.FromImage(gPictureBoxLayer(gSelectLayerNo).Image)
    mGraphics.Clear(Color.Transparent)
    mGraphics.DrawImage(PictureBoxWork.Image, New Rectangle(New Point(0, 0), gBitmapDraw.Size), 0, 0, gBitmapDraw.Width, gBitmapDraw.Height, GraphicsUnit.Pixel)
    gPictureBoxLayer(gSelectLayerNo).Invalidate()

    '直前の処理にフォーカスする
    Select Case gDrawMode
      Case DrawMode.modePencil
        Me.RadioButtonPencil.Focus()
      Case DrawMode.modeEraser
        Me.RadioButtonEraser.Focus()
      Case DrawMode.modeLine
        Me.RadioButtonLine.Focus()
      Case DrawMode.modeSquare
        Me.RadioButtonSquare.Focus()
      Case DrawMode.modeCircle
        Me.RadioButtonCircle.Focus()
    End Select

  End Sub
  '**************************************************
  ' 直線
  Private Sub RadioButtonLine_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonLine.CheckedChanged

    gDrawMode = DrawMode.modeLine

  End Sub
  '**************************************************
  ' 四角
  Private Sub RadioButtonSquare_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonSquare.CheckedChanged

    gDrawMode = DrawMode.modeSquare

  End Sub
  '**************************************************
  ' 円
  Private Sub RadioButtonCircle_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonCircle.CheckedChanged

    gDrawMode = DrawMode.modeCircle

  End Sub
  '**************************************************
  ' メニュー
  '**************************************************
  '**************************************************
  ' 新規作成
  Private Sub ToolStripMenuItemFileNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItemFileNew.Click

    '保存の判定を行う
    If SaveCheck() = True Then
      FrmFileNew.ShowDialog()
    End If

  End Sub
  '**************************************************
  ' プロジェクトファイルを開く
  Private Sub ToolStripMenuItemFileProjectOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItemFileProjectOpen.Click

    '保存の判定を行う
    If SaveCheck() = True Then
      '最後に開いたプロジェクトファイルのフォルダをデフォルトとする
      If My.Settings.LastOpen.Length = 0 Then
        '最後に開いたフォルダが無いときは、マイ ドキュメントフォルダとする
        My.Settings.LastOpen = System.Environment.GetFolderPath(Environment.SpecialFolder.Personal)
      Else
        If System.IO.Directory.Exists(My.Settings.LastOpen) = False Then
          '最後に開いたフォルダが、存在しないときも、マイ ドキュメントフォルダとする
          My.Settings.LastOpen = System.Environment.GetFolderPath(Environment.SpecialFolder.Personal)
        End If
      End If

      'ファイルダイアログを開く
      Me.OpenFileDialog.Title = "プロジェクトファイルを開く"
      Me.OpenFileDialog.InitialDirectory = My.Settings.LastOpen
      Me.OpenFileDialog.FileName = ""
      Me.OpenFileDialog.Filter = "ミカペン プロジェクト|*" & EX_NAME

      If Me.OpenFileDialog.ShowDialog() = DialogResult.OK Then
        gProjectSavePath = System.IO.Path.GetDirectoryName(Me.OpenFileDialog.FileName)
        If gProjectSavePath.EndsWith("\") = False Then gProjectSavePath = gProjectSavePath & "\"
        gProjectNameEx = System.IO.Path.GetFileName(Me.OpenFileDialog.FileName)
        gProjectName = System.IO.Path.GetFileNameWithoutExtension(gProjectNameEx)
        My.Settings.LastOpen = gProjectSavePath

        'レイヤーの情報を削除
        LayerAllDel()

        'レイヤーの情報を取得
        GetLayerInfo()
        gSelectLayerNo = 1
        LayerSelectColor(gSelectLayerNo)
        LayerWorkSet()

        'タイトルバーの表示
        Me.Text = Application.ProductName & " (" & gProjectName & " " & My.Settings.CanvasWidth & " x " & My.Settings.CanvasHeight & ")"
      End If
    End If

  End Sub
  '**************************************************
  ' プロジェクトの上書き保存
  Private Sub ToolStripMenuItemFileProjectSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItemFileProjectSave.Click

    ProjectSaveRtn()

  End Sub
  '**************************************************
  ' 名前を付けてプロジェクトの保存
  Private Sub ToolStripMenuItemFileProjectSaveName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItemFileProjectSaveName.Click

    ProjectSaveNameRtn()

  End Sub
  '**************************************************
  ' 画像ファイルの保存
  Private Sub ToolStripMenuItemFilePictureSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItemFilePictureSave.Click
    Dim mGraphics As Graphics
    Dim mSavePath As String
    Dim mFileName As String
    Dim i As Integer
    Dim result As DialogResult

    mSavePath = System.Environment.GetFolderPath(Environment.SpecialFolder.MyPictures)

    'ファイルダイアログを開く
    Me.SaveFileDialog.Title = "画像ファイルの保存"
    Me.SaveFileDialog.InitialDirectory = mSavePath
    Me.SaveFileDialog.FileName = gProjectName
    Me.SaveFileDialog.Filter = "PNG|*.png|BMP|*.bmp|JPEG|*.jpg"

    If Me.SaveFileDialog.ShowDialog() = DialogResult.OK Then
      mSavePath = System.IO.Path.GetDirectoryName(Me.SaveFileDialog.FileName)
      If mSavePath.EndsWith("\") = False Then mSavePath = mSavePath & "\"
      mFileName = System.IO.Path.GetFileName(Me.SaveFileDialog.FileName)

      'PictureBoxWorkを、保存用に使用する(各レイヤーを一つにまとめる)
      'PictureBoxWorkの設定
      mGraphics = Graphics.FromImage(Me.PictureBoxWork.Image)
      mGraphics.Clear(Color.Transparent) 'Clear(Color.White)
      For i = gLayerNum To 1 Step -1
        mGraphics.DrawImage(gPictureBoxLayer(i).Image, New Rectangle(New Point(0, 0), gBitmap(i).Size), 0, 0, gBitmap(i).Width, gBitmap(i).Height, GraphicsUnit.Pixel)
      Next i
      Me.PictureBoxWork.Invalidate() 'chk
      Try
        Select Case SaveFileDialog.FilterIndex
          Case 1
            PictureBoxWork.Image.Save(mSavePath & mFileName, System.Drawing.Imaging.ImageFormat.Png)
          Case 2
            result = MessageBox.Show("透過情報は失われますが保存しますか？", Application.ProductName, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)
            If result = DialogResult.Yes Then
              PictureBoxWork.Image.Save(mSavePath & mFileName, System.Drawing.Imaging.ImageFormat.Bmp)
            End If
          Case 3
            result = MessageBox.Show("透過情報は失われますが保存しますか？", Application.ProductName, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)
            If result = DialogResult.Yes Then
              PictureBoxWork.Image.Save(mSavePath & mFileName, System.Drawing.Imaging.ImageFormat.Jpeg)
            End If
        End Select
      Catch ex As Exception
        MessageBox.Show("画像ファイルの保存に失敗しました", Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
      End Try

      'PictureBoxWorkを、元の情報に戻す
      LayerWorkSet()

      gUpdFlg = False
    End If

  End Sub
  '**************************************************
  ' 終了
  Private Sub ToolStripMenuItemFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItemFileExit.Click

    Application.Exit() 'FormClosingで、SaveCheck()が処理される

  End Sub
  '**************************************************
  ' ウィンドウサイズリセット
  Private Sub ToolStripMenuItemSettingResetWindowSize_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItemSettingResetWindowSize.Click

    Me.Location = New Size(100, 100)
    Me.Size = New Size(650, 520)

  End Sub
  '**************************************************
  ' ピクチャーボックスリセット
  Private Sub ToolStripMenuItemSettingResetPictureBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItemSettingResetPictureBox.Click

    My.Settings.CanvasWidth = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width
    My.Settings.CanvasHeight = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height

    'ピクチャーボックスの大きさを設定
    PictureBoxSizeSet()

    'タイトルバーの表示
    Me.Text = Application.ProductName & " (" & gProjectName & " " & My.Settings.CanvasWidth & " x " & My.Settings.CanvasHeight & ")"

  End Sub
  '**************************************************
  ' ヘルプを表示
  '**************************************************
  Private Sub ToolStripMenuItemHelpReadme_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItemHelpReadme.Click

    If System.IO.File.Exists(gHelpFilePath) Then
      System.Diagnostics.Process.Start(gHelpFilePath)
    Else
      MessageBox.Show(gHelpFilePath & " がみつかりません", Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
    End If

  End Sub
  '**************************************************
  ' ホームページを表示
  '**************************************************
  Private Sub ToolStripMenuItemHelpWeb_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItemHelpWeb.Click

    System.Diagnostics.Process.Start(WEB_URL)

  End Sub
  '**************************************************
  ' バージョン情報
  '**************************************************
  Private Sub ToolStripMenuItemHelpVersion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripMenuItemHelpVersion.Click

    MessageBox.Show(Application.ProductName & " Ver " & Application.ProductVersion, Application.ProductName, MessageBoxButtons.OK)

  End Sub
  '**************************************************
  ' マウス
  '**************************************************
  '**************************************************
  ' マウスがピクチャーボックスから外れたとき
  Private Sub PictureBoxTop_MouseLeave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBoxTop.MouseLeave
    Dim penHalfWidth As Integer

    Me.PictureBoxTop.Cursor = Cursors.Default

    If gDrawMode = DrawMode.modeEraser Then
      '消しゴムのときは、ガイドの円を消す
      penHalfWidth = gPenWidth / 2
      gGraphicsTop.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceCopy
      gGraphicsTop.DrawEllipse(gPenEraseW1, gMouseFromX - penHalfWidth, gMouseFromY - penHalfWidth, gPenWidth, gPenWidth)
      gGraphicsTop.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceOver
      Me.PictureBoxTop.Invalidate()
    End If

  End Sub
  '**************************************************
  ' マウスの移動
  Private Sub PictureBoxTop_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBoxTop.MouseMove
    Dim penHalfWidth As Integer

    Me.ToolStripStatusLabelPos.Text = "位置: " & e.X & " ｘ " & e.Y

    If gSelectLayerNo <= 0 Then
      Exit Sub
    End If

    Me.PictureBoxTop.Cursor = Cursors.Cross

    '**************************************************
    ' エンピツ
    If gDrawMode = DrawMode.modePencil Then
      If gWritingFlg = True Then
        If (e.Button = MouseButtons.Left) Or (e.Button = MouseButtons.Right) Then
          gGraphicsDraw.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceCopy
          penHalfWidth = gPenWidth / 2
          gGraphicsDraw.DrawLine(gCurrentPen, gMouseFromX, gMouseFromY, e.X, e.Y)
          gGraphicsDraw.FillEllipse(gCurrentSolidBrush, e.X - penHalfWidth, e.Y - penHalfWidth, gPenWidth, gPenWidth)
          gGraphicsDraw.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceOver
          Me.PictureBoxDraw.Invalidate()
        End If
      End If
    End If
    '**************************************************
    ' 消しゴム
    If gDrawMode = DrawMode.modeEraser Then
      penHalfWidth = gPenWidth / 2
      '消去範囲のガイドライン
      gGraphicsTop.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceCopy
      gGraphicsTop.DrawEllipse(gPenEraseW1, gMouseFromX - penHalfWidth, gMouseFromY - penHalfWidth, gPenWidth, gPenWidth)
      gGraphicsTop.DrawEllipse(gPenBlackW1, e.X - penHalfWidth, e.Y - penHalfWidth, gPenWidth, gPenWidth)
      gGraphicsTop.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceOver
      Me.PictureBoxTop.Invalidate()
      If gWritingFlg = True Then
        If e.Button = MouseButtons.Left Then
          gGraphicsWork.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceCopy
          gGraphicsWork.DrawLine(gPenErase, gMouseFromX, gMouseFromY, e.X, e.Y)
          gGraphicsWork.FillEllipse(gSolidBrushErase, e.X - penHalfWidth, e.Y - penHalfWidth, gPenWidth, gPenWidth)
          gGraphicsWork.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceOver
          Me.PictureBoxWork.Invalidate()
        End If
      End If
    End If
    '**************************************************
    ' 直線
    If gDrawMode = DrawMode.modeLine Then
      If gWritingFlg = True Then
        If (e.Button = MouseButtons.Left) Or (e.Button = MouseButtons.Right) Then
          penHalfWidth = gPenWidth / 2
          gGraphicsDraw.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceCopy
          gGraphicsDraw.DrawLine(gPenErase, gMouseBaseX, gMouseBaseY, gMouseFromX, gMouseFromY)
          gGraphicsDraw.FillEllipse(gSolidBrushErase, gMouseFromX - penHalfWidth, gMouseFromY - penHalfWidth, gPenWidth, gPenWidth)
          gGraphicsDraw.FillEllipse(gCurrentSolidBrush, gMouseBaseX - penHalfWidth, gMouseBaseY - penHalfWidth, gPenWidth, gPenWidth)
          gGraphicsDraw.DrawLine(gCurrentPen, gMouseBaseX, gMouseBaseY, e.X, e.Y)
          gGraphicsDraw.FillEllipse(gCurrentSolidBrush, e.X - penHalfWidth, e.Y - penHalfWidth, gPenWidth, gPenWidth)
          gGraphicsDraw.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceOver
          Me.PictureBoxDraw.Invalidate()
          Me.ToolStripStatusLabelOffset.Text = "範囲: " & e.X - gMouseBaseX & " ｘ " & e.Y - gMouseBaseY
        End If
      End If
    End If
    '**************************************************
    ' 四角
    If gDrawMode = DrawMode.modeSquare Then
      If gWritingFlg = True Then
        If (e.Button = MouseButtons.Left) Or (e.Button = MouseButtons.Right) Then
          gGraphicsDraw.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceCopy
          If (gMouseFromX < gMouseBaseX) And (gMouseFromY >= gMouseBaseY) Then '左下
            gGraphicsDraw.DrawRectangle(gPenErase, gMouseFromX, gMouseBaseY, gMouseBaseX - gMouseFromX, gMouseFromY - gMouseBaseY)
          End If
          If (gMouseFromX >= gMouseBaseX) And (gMouseFromY < gMouseBaseY) Then '右上
            gGraphicsDraw.DrawRectangle(gPenErase, gMouseBaseX, gMouseFromY, gMouseFromX - gMouseBaseX, gMouseBaseY - gMouseFromY)
          End If
          If (gMouseFromX < gMouseBaseX) And (gMouseFromY < gMouseBaseY) Then '左上
            gGraphicsDraw.DrawRectangle(gPenErase, gMouseFromX, gMouseFromY, gMouseBaseX - gMouseFromX, gMouseBaseY - gMouseFromY)
          End If
          If (gMouseFromX >= gMouseBaseX) And (gMouseFromY >= gMouseBaseY) Then '右下
            gGraphicsDraw.DrawRectangle(gPenErase, gMouseBaseX, gMouseBaseY, gMouseFromX - gMouseBaseX, gMouseFromY - gMouseBaseY)
          End If

          If (e.X < gMouseBaseX) And (e.Y >= gMouseBaseY) Then '左下
            gGraphicsDraw.DrawRectangle(gCurrentPen, e.X, gMouseBaseY, gMouseBaseX - e.X, e.Y - gMouseBaseY)
          End If
          If (e.X >= gMouseBaseX) And (e.Y < gMouseBaseY) Then '右上
            gGraphicsDraw.DrawRectangle(gCurrentPen, gMouseBaseX, e.Y, e.X - gMouseBaseX, gMouseBaseY - e.Y)
          End If
          If (e.X < gMouseBaseX) And (e.Y < gMouseBaseY) Then '左上
            gGraphicsDraw.DrawRectangle(gCurrentPen, e.X, e.Y, gMouseBaseX - e.X, gMouseBaseY - e.Y)
          End If
          If (e.X >= gMouseBaseX) And (e.Y >= gMouseBaseY) Then '右下
            gGraphicsDraw.DrawRectangle(gCurrentPen, gMouseBaseX, gMouseBaseY, e.X - gMouseBaseX, e.Y - gMouseBaseY)
          End If
          gGraphicsDraw.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceOver
          Me.PictureBoxDraw.Invalidate()
          Me.ToolStripStatusLabelOffset.Text = "範囲: " & e.X - gMouseBaseX & " ｘ " & e.Y - gMouseBaseY
        End If
      End If
    End If
    '**************************************************
    ' 円
    If gDrawMode = DrawMode.modeCircle Then
      If gWritingFlg = True Then
        If (e.Button = MouseButtons.Left) Or (e.Button = MouseButtons.Right) Then
          gGraphicsDraw.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceCopy
          If (gMouseFromX < gMouseBaseX) And (gMouseFromY >= gMouseBaseY) Then '左下
            gGraphicsDraw.DrawEllipse(gPenErase, gMouseFromX, gMouseBaseY, gMouseBaseX - gMouseFromX, gMouseFromY - gMouseBaseY)
          End If
          If (gMouseFromX >= gMouseBaseX) And (gMouseFromY < gMouseBaseY) Then '右上
            gGraphicsDraw.DrawEllipse(gPenErase, gMouseBaseX, gMouseFromY, gMouseFromX - gMouseBaseX, gMouseBaseY - gMouseFromY)
          End If
          If (gMouseFromX < gMouseBaseX) And (gMouseFromY < gMouseBaseY) Then '左上
            gGraphicsDraw.DrawEllipse(gPenErase, gMouseFromX, gMouseFromY, gMouseBaseX - gMouseFromX, gMouseBaseY - gMouseFromY)
          End If
          If (gMouseFromX >= gMouseBaseX) And (gMouseFromY >= gMouseBaseY) Then '右下
            gGraphicsDraw.DrawEllipse(gPenErase, gMouseBaseX, gMouseBaseY, gMouseFromX - gMouseBaseX, gMouseFromY - gMouseBaseY)
          End If

          If (e.X < gMouseBaseX) And (e.Y >= gMouseBaseY) Then '左下
            gGraphicsDraw.DrawEllipse(gCurrentPen, e.X, gMouseBaseY, gMouseBaseX - e.X, e.Y - gMouseBaseY)
          End If
          If (e.X >= gMouseBaseX) And (e.Y < gMouseBaseY) Then '右上
            gGraphicsDraw.DrawEllipse(gCurrentPen, gMouseBaseX, e.Y, e.X - gMouseBaseX, gMouseBaseY - e.Y)
          End If
          If (e.X < gMouseBaseX) And (e.Y < gMouseBaseY) Then '左上
            gGraphicsDraw.DrawEllipse(gCurrentPen, e.X, e.Y, gMouseBaseX - e.X, gMouseBaseY - e.Y)
          End If
          If (e.X >= gMouseBaseX) And (e.Y >= gMouseBaseY) Then '右下
            gGraphicsDraw.DrawEllipse(gCurrentPen, gMouseBaseX, gMouseBaseY, e.X - gMouseBaseX, e.Y - gMouseBaseY)
          End If
          gGraphicsDraw.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceOver
          Me.PictureBoxDraw.Invalidate()
          Me.ToolStripStatusLabelOffset.Text = "範囲: " & e.X - gMouseBaseX & " ｘ " & e.Y - gMouseBaseY
        End If
      End If
    End If
    gMouseFromX = e.X
    gMouseFromY = e.Y

  End Sub
  '**************************************************
  ' マウスのボタンを押したとき
  Private Sub PictureBoxTop_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBoxTop.MouseDown
    Dim penHalfWidth As Integer

    If gWritingFlg = False Then
      gWritingFlg = True
      gUpdFlg = True '更新あり
      '**************************************************
      ' エンピツ
      If gDrawMode = DrawMode.modePencil Then
        If (e.Button = MouseButtons.Left) Or (e.Button = MouseButtons.Right) Then
          'ペンやブラシが選択されていないときは抜ける
          If IsNothing(gPenErase) Or IsNothing(gSolidBrushErase) Then
            gWritingFlg = False
            Exit Sub
          End If
          If e.Button = MouseButtons.Left Then
            gCurrentPen = gPenLeft
            gCurrentSolidBrush = gSolidBrushLeft
          End If
          If e.Button = MouseButtons.Right Then
            gCurrentPen = gPenRight
            gCurrentSolidBrush = gSolidBrushRight
          End If
          '直前の描画を、反映させる
          gGraphicsWork.DrawImage(PictureBoxDraw.Image, New Rectangle(New Point(0, 0), gBitmapDraw.Size), 0, 0, gBitmapDraw.Width, gBitmapDraw.Height, GraphicsUnit.Pixel)
          gGraphicsDraw.Clear(Color.Transparent)
          Me.PictureBoxDraw.Invalidate()
          '点を描画
          penHalfWidth = gPenWidth / 2
          gGraphicsDraw.FillEllipse(gCurrentSolidBrush, e.X - penHalfWidth, e.Y - penHalfWidth, gPenWidth, gPenWidth)
          Me.PictureBoxDraw.Invalidate()
        End If
      End If
      '**************************************************
      ' 消しゴム
      If gDrawMode = DrawMode.modeEraser Then
        If e.Button = MouseButtons.Left Then
          '直前の描画を、反映させる
          gGraphicsWork.DrawImage(PictureBoxDraw.Image, New Rectangle(New Point(0, 0), gBitmapDraw.Size), 0, 0, gBitmapDraw.Width, gBitmapDraw.Height, GraphicsUnit.Pixel)
          gGraphicsDraw.Clear(Color.Transparent)
          Me.PictureBoxDraw.Invalidate()

          '点を描画
          penHalfWidth = gPenWidth / 2
          gGraphicsWork.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceCopy
          gGraphicsWork.FillEllipse(gSolidBrushErase, e.X - penHalfWidth, e.Y - penHalfWidth, gPenWidth, gPenWidth)
          gGraphicsWork.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceOver
          Me.PictureBoxWork.Invalidate()
        End If
      End If
      '**************************************************
      ' 直線
      If gDrawMode = DrawMode.modeLine Then
        If (e.Button = MouseButtons.Left) Or (e.Button = MouseButtons.Right) Then
          'ペンやブラシが選択されていないときは抜ける
          If IsNothing(gPenErase) Or IsNothing(gSolidBrushErase) Then
            gWritingFlg = False
            Exit Sub
          End If
          If e.Button = MouseButtons.Left Then
            gCurrentPen = gPenLeft
            gCurrentSolidBrush = gSolidBrushLeft
          End If
          If e.Button = MouseButtons.Right Then
            gCurrentPen = gPenRight
            gCurrentSolidBrush = gSolidBrushRight
          End If
          '直前の描画を、反映させる
          gGraphicsWork.DrawImage(PictureBoxDraw.Image, New Rectangle(New Point(0, 0), gBitmapDraw.Size), 0, 0, gBitmapDraw.Width, gBitmapDraw.Height, GraphicsUnit.Pixel)
          gGraphicsDraw.Clear(Color.Transparent)
          Me.PictureBoxDraw.Invalidate()
          '点を描画
          penHalfWidth = gPenWidth / 2
          gGraphicsDraw.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceCopy
          gGraphicsDraw.FillEllipse(gCurrentSolidBrush, e.X - penHalfWidth, e.Y - penHalfWidth, gPenWidth, gPenWidth)
          gGraphicsDraw.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceOver
          Me.PictureBoxDraw.Invalidate()
        End If
      End If
      '**************************************************
      ' 四角、円
      If (gDrawMode = DrawMode.modeSquare) Or (gDrawMode = DrawMode.modeCircle) Then
        If (e.Button = MouseButtons.Left) Or (e.Button = MouseButtons.Right) Then
          'ペンやブラシが選択されていないときは抜ける
          If IsNothing(gPenErase) Or IsNothing(gSolidBrushErase) Then
            gWritingFlg = False
            Exit Sub
          End If
          If e.Button = MouseButtons.Left Then
            gCurrentPen = gPenLeft
            gCurrentSolidBrush = gSolidBrushLeft
          End If
          If e.Button = MouseButtons.Right Then
            gCurrentPen = gPenRight
            gCurrentSolidBrush = gSolidBrushRight
          End If
          '直前の描画を、反映させる
          gGraphicsWork.DrawImage(PictureBoxDraw.Image, New Rectangle(New Point(0, 0), gBitmapDraw.Size), 0, 0, gBitmapDraw.Width, gBitmapDraw.Height, GraphicsUnit.Pixel)
          gGraphicsDraw.Clear(Color.Transparent)
          Me.PictureBoxDraw.Invalidate()
        End If
      End If
      gMouseBaseX = e.X
      gMouseBaseY = e.Y
      gMouseFromX = e.X
      gMouseFromY = e.Y
    End If

  End Sub
  '**************************************************
  ' マウスのボタンを離したとき
  Private Sub PictureBoxTop_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBoxTop.MouseUp
    Dim mGraphics As Graphics
    Dim penHalfWidth As Integer

    If gWritingFlg = True Then
      gWritingFlg = False
      gMouseBaseX = -1
      gMouseBaseY = -1
      gMouseFromX = -1
      gMouseFromY = -1

      mGraphics = Graphics.FromImage(gPictureBoxLayer(gSelectLayerNo).Image)
      mGraphics.Clear(Color.Transparent)
      mGraphics.DrawImage(PictureBoxWork.Image, New Rectangle(New Point(0, 0), gBitmapDraw.Size), 0, 0, gBitmapDraw.Width, gBitmapDraw.Height, GraphicsUnit.Pixel)
      mGraphics.DrawImage(PictureBoxDraw.Image, New Rectangle(New Point(0, 0), gBitmapDraw.Size), 0, 0, gBitmapDraw.Width, gBitmapDraw.Height, GraphicsUnit.Pixel)
      gPictureBoxLayer(gSelectLayerNo).Invalidate()

      If gDrawMode = DrawMode.modeEraser Then
        '消しゴムのときは、ガイドの円を消す
        penHalfWidth = gPenWidth / 2
        gGraphicsTop.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceCopy
        gGraphicsTop.DrawEllipse(gPenEraseW1, e.X - penHalfWidth, e.Y - penHalfWidth, gPenWidth, gPenWidth)
        gGraphicsTop.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceOver
        Me.PictureBoxTop.Invalidate()
      End If

      Me.ToolStripStatusLabelOffset.Text = "範囲"
    End If

  End Sub
  '**************************************************
  'イベントハンドラー
  '**************************************************
  '**************************************************
  ' レイヤー名のテキストをクリック
  Public Sub mTextBoxLayerName_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Dim no As Integer

    no = Integer.Parse(CType(sender, System.Windows.Forms.TextBox).Tag)

    If gSelectLayerNo <> no Then
      '新たに選択された部分を水色に
      gPanelLayer(no).BackColor = Color.Aquamarine
      gTextBoxLayerName(no).BackColor = Color.Aquamarine
      gTextBoxLayerName(no).Focus() 'フォーカス移動元のテキストボックスのLeaveイベントを発生させるため
      '選択されていた部分を白色に
      gPanelLayer(gSelectLayerNo).BackColor = Color.White
      gTextBoxLayerName(gSelectLayerNo).BackColor = Color.White

      gSelectLayerNo = no
      LayerWorkSet()
    End If

  End Sub
  '**************************************************
  ' レイヤーのピクチャーをクリック
  Public Sub mPictureboxLayer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Dim no As Integer

    no = Integer.Parse(CType(sender, System.Windows.Forms.PictureBox).Tag)

    If gSelectLayerNo <> no Then
      '新たに選択された部分を水色に
      gPanelLayer(no).BackColor = Color.Aquamarine
      gTextBoxLayerName(no).BackColor = Color.Aquamarine
      gTextBoxLayerName(no).Focus() 'フォーカス移動元のテキストボックスのLeaveイベントを発生させるため
      '選択されていた部分を白色に
      gPanelLayer(gSelectLayerNo).BackColor = Color.White
      gTextBoxLayerName(gSelectLayerNo).BackColor = Color.White

      gSelectLayerNo = no
      LayerWorkSet()
    End If

  End Sub
  '**************************************************
  ' レイヤーのパネルをクリック
  Public Sub mPanelLayer_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Dim no As Integer

    no = Integer.Parse(CType(sender, System.Windows.Forms.Panel).Tag)

    If gSelectLayerNo <> no Then
      '新たに選択された部分を水色に
      gPanelLayer(no).BackColor = Color.Aquamarine
      gTextBoxLayerName(no).BackColor = Color.Aquamarine
      gTextBoxLayerName(no).Focus() 'フォーカス移動元のテキストボックスのLeaveイベントを発生させるため
      '選択されていた部分を白色に
      gPanelLayer(gSelectLayerNo).BackColor = Color.White
      gTextBoxLayerName(gSelectLayerNo).BackColor = Color.White

      gSelectLayerNo = no
      LayerWorkSet()
    End If

  End Sub
  '**************************************************
  ' レイヤー番号のテキストをダブルクリック
  Public Sub mTextBoxLayerName_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Dim no As Integer

    gUpdFlg = True '更新あり

    no = Integer.Parse(CType(sender, System.Windows.Forms.TextBox).Tag)

    'レイヤー番号を、編集可能とする
    gTextBoxLayerName(no).ReadOnly = False
    gTextBoxLayerName(no).BackColor = Color.White

  End Sub
  '**************************************************
  ' レイヤー番号のテキストでEnterキー
  Public Sub mTextBoxLayerName_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs)
    Dim no As Integer

    no = Integer.Parse(CType(sender, System.Windows.Forms.TextBox).Tag)

    If e.KeyCode = Keys.Enter Then
      '編集確定とする
      gTextBoxLayerName(no).ReadOnly = True
      gTextBoxLayerName(no).BackColor = Color.Aquamarine

      e.Handled = True
    End If

  End Sub
  '**************************************************
  ' レイヤー番号のテキストから、フォーカスが外れたとき
  Public Sub mTextBoxLayerName_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs)
    Dim no As Integer

    no = Integer.Parse(CType(sender, System.Windows.Forms.TextBox).Tag)

    '編集確定とする
    gTextBoxLayerName(no).ReadOnly = True
    gTextBoxLayerName(no).BackColor = Color.Aquamarine

  End Sub
  '**************************************************
  ' ラベル
  '**************************************************
  '**************************************************
  ' 色ラベル
  ' 各色のイベントは、全部ここで処理します
  Private Sub LabelColor_MouseClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles LabelColor1.MouseClick, LabelColor2.MouseClick, LabelColor3.MouseClick, LabelColor4.MouseClick, LabelColor5.MouseClick, LabelColor6.MouseClick, LabelColor7.MouseClick, LabelColor8.MouseClick, LabelColor9.MouseClick, LabelColor10.MouseClick

    If e.Button = MouseButtons.Left Then
      '左クリック時の色選択
      Me.LabelMouseLeft.BackColor = CType(sender, System.Windows.Forms.Label).BackColor
      gColorLeft = CType(sender, System.Windows.Forms.Label).BackColor
      ColorSet()
    End If
    If e.Button = MouseButtons.Right Then
      '右クリック時の色選択
      Me.LabelMouseRight.BackColor = CType(sender, System.Windows.Forms.Label).BackColor
      gColorRight = CType(sender, System.Windows.Forms.Label).BackColor
      ColorSet()
    End If

  End Sub
  '**************************************************
  ' トラックバー
  '**************************************************
  '**************************************************
  ' 線幅トラックバー
  Private Sub TrackBarLineWidth_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBarLineWidth.Scroll

    gPenWidth = Me.TrackBarLineWidth.Value

    Me.LabelWidthText.Text = "線幅:" & gPenWidth
    ColorSet()

  End Sub
  '**************************************************
  ' 透過トラックバー
  Private Sub TrackBarLineTrans_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBarLineTrans.Scroll

    gPenTrans = Me.TrackBarLineTrans.Value

    Me.LabelTransText.Text = "透過:" & gPenTrans
    ColorSet()

  End Sub

End Class
