﻿Option Explicit On

Module MdlMikaFile

  '定数
  Public Const HELP_FILENAME = "help\MikaPen.txt" 'ヘルプファイルの場所

  'フラグや、一時的な変数
  Public gProjectNameEx As String   '保存したプロジェクト名:"ぶどうの絵.mpj"などの拡張子付き
  Public gProjectName As String     '拡張子無しのプロジェクト名:"ぶどうの絵"など
  Public gProjectSavePath As String 'プロジェクトを保存した場所
  Public gHelpFilePath As String    'ヘルプファイルの場所

  '**************************************************
  ' プロジェクトの上書き保存
  '**************************************************
  Public Sub ProjectSaveRtn()
    Dim mGraphics As Graphics
    Dim projectFile As System.IO.StreamWriter
    Dim i As Integer

    If gProjectName = NON_TITLE Then
      '名前を付けて保存
      ProjectSaveNameRtn()
    Else
      'PictureBoxWorkを、保存用に使用する
      'PictureBoxWorkの設定
      mGraphics = Graphics.FromImage(FrmMikapen.PictureBoxWork.Image)
      Try
        'プロジェクトファイルの出力
        projectFile = New System.IO.StreamWriter(gProjectSavePath & "\" & gProjectNameEx, False, System.Text.Encoding.Default)

        projectFile.WriteLine("X," & My.Settings.CanvasWidth) 'キャンバスのXサイズ
        projectFile.WriteLine("Y," & My.Settings.CanvasHeight) 'キャンバスのYサイズ

        For i = 1 To gLayerNum
          projectFile.WriteLine(i & "," & gTextBoxLayerName(i).Text & ".png") '連番とファイル名

          mGraphics.Clear(Color.Transparent) 'Clear(Color.White)
          mGraphics.DrawImage(gPictureBoxLayer(i).Image, New Rectangle(New Point(0, 0), gBitmap(i).Size), 0, 0, gBitmap(i).Width, gBitmap(i).Height, GraphicsUnit.Pixel)
          FrmMikapen.PictureBoxWork.Invalidate() 'chk
          FrmMikapen.PictureBoxWork.Image.Save(gProjectSavePath & "\" & gProjectName & LAYER_NAME & "\" & gTextBoxLayerName(i).Text & ".png", System.Drawing.Imaging.ImageFormat.Png)
        Next i
        projectFile.Close()
      Catch ex As Exception
        MessageBox.Show("プロジェクトファイルの保存に失敗しました", Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
      End Try

      'PictureBoxWorkを、元の情報に戻す
      LayerWorkSet()

      gUpdFlg = False
    End If

  End Sub
  '**************************************************
  ' 名前を付けてプロジェクトの保存
  ' プロジェクト名の親フォルダは作成しない
  ' 選択したフォルダに下記を作成する
  '   プロジェクト名.mpj (プロジェクトファイル)
  '   プロジェクト名_Layerフォルダ
  '    |-レイヤー1.png (レイヤー用画像)
  '    |-レイヤー2.png (レイヤー用画像)
  '    |-レイヤー3.png (レイヤー用画像)
  '**************************************************
  Public Function ProjectSaveNameRtn() As Boolean
    Dim mGraphics As Graphics
    Dim projectFile As System.IO.StreamWriter
    Dim mSavePath As String
    Dim mFileName As String
    Dim i As Integer
    Dim result As DialogResult

    mSavePath = System.Environment.GetFolderPath(Environment.SpecialFolder.Personal) 'c:\Users\xxxx\Documents

    'ファイルダイアログを開く
    FrmMikapen.SaveFileDialog.Title = "名前を付けてプロジェクトの保存"
    FrmMikapen.SaveFileDialog.InitialDirectory = mSavePath
    FrmMikapen.SaveFileDialog.FileName = gProjectName
    FrmMikapen.SaveFileDialog.Filter = "ミカペン プロジェクト|*" & EX_NAME

    If FrmMikapen.SaveFileDialog.ShowDialog() = DialogResult.OK Then
      mSavePath = System.IO.Path.GetDirectoryName(FrmMikapen.SaveFileDialog.FileName) 'c:\Users\xxxx\Documents
      mFileName = System.IO.Path.GetFileName(FrmMikapen.SaveFileDialog.FileName)
      gProjectSavePath = mSavePath
      gProjectNameEx = mFileName
      gProjectName = System.IO.Path.GetFileNameWithoutExtension(gProjectNameEx)

      'すでに同名のレイヤーファイル用のフォルダが存在しているかどうか確認する
      If System.IO.Directory.Exists(mSavePath & "\" & gProjectName & LAYER_NAME) Then
        result = MessageBox.Show("すでにレイヤーファイル用のフォルダが存在します、上書きしますか？", Application.ProductName, MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1)
        If result = DialogResult.No Then
          Return False
        End If
      End If

      'PictureBoxWorkを、保存用に使用する
      'PictureBoxWorkの設定
      mGraphics = Graphics.FromImage(FrmMikapen.PictureBoxWork.Image)
      Try
        'レイヤーファイル用のフォルダの作成
        System.IO.Directory.CreateDirectory(mSavePath & "\" & gProjectName & LAYER_NAME)

        'プロジェクトファイルの出力
        projectFile = New System.IO.StreamWriter(mSavePath & "\" & mFileName, False, System.Text.Encoding.Default)

        projectFile.WriteLine("X," & My.Settings.CanvasWidth) 'キャンバスのXサイズ
        projectFile.WriteLine("Y," & My.Settings.CanvasHeight) 'キャンバスのYサイズ

        For i = 1 To gLayerNum
          projectFile.WriteLine(i & "," & gTextBoxLayerName(i).Text & ".png") '連番とファイル名

          mGraphics.Clear(Color.Transparent) 'Clear(Color.White)
          mGraphics.DrawImage(gPictureBoxLayer(i).Image, New Rectangle(New Point(0, 0), gBitmap(i).Size), 0, 0, gBitmap(i).Width, gBitmap(i).Height, GraphicsUnit.Pixel)
          FrmMikapen.PictureBoxWork.Invalidate() 'chk
          FrmMikapen.PictureBoxWork.Image.Save(mSavePath & "\" & gProjectName & LAYER_NAME & "\" & gTextBoxLayerName(i).Text & ".png", System.Drawing.Imaging.ImageFormat.Png)
        Next i
        projectFile.Close()
      Catch ex As Exception
        MessageBox.Show("プロジェクトファイルの保存に失敗しました", Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
      End Try

      'PictureBoxWorkを、元の情報に戻す
      LayerWorkSet()

      'タイトルバーの表示
      FrmMikapen.Text = Application.ProductName & " (" & gProjectName & " " & My.Settings.CanvasWidth & " x " & My.Settings.CanvasHeight & ")"

      gUpdFlg = False
      Return True
    Else
      Return False
    End If

  End Function

End Module
