﻿Option Explicit On

Module MdlMikaLayer

  '定数
  Public Const LAYER_MAX = 10 'レイヤーの最大数

  '描画用のオブジェクト
  Public gGraphicsTop As Graphics  '描画補助用の最上位のレイヤー
  Public gGraphicsDraw As Graphics '最新の描画を行うレイヤー
  Public gGraphicsWork As Graphics '描画を行うレイヤー

  Public gBitmapDraw As Bitmap '最新の描画を行うレイヤー用のビットマップ

  Public gPanelLayer() As Windows.Forms.Panel
  Public gPictureBoxLayer() As Windows.Forms.PictureBox
  Public gTextBoxLayerName() As Windows.Forms.TextBox
  Public gBitmap() As Bitmap

  'フラグや、一時的な変数
  Public gLayerNum As Integer      'レイヤーの総数
  Public gSelectLayerNo As Integer '選択されているレイヤー

  '**************************************************
  ' レイヤーの追加
  '**************************************************
  Public Sub LayerAdd()

    If gLayerNum >= LAYER_MAX Then
      Exit Sub
    End If
    gLayerNum = gLayerNum + 1

    ReDim Preserve gPanelLayer(gLayerNum)
    ReDim Preserve gPictureBoxLayer(gLayerNum)
    ReDim Preserve gTextBoxLayerName(gLayerNum)
    ReDim Preserve gBitmap(gLayerNum)

    'ベースとなるパネルの高さを設定
    FrmMikapen.PanelFront.Height = FrmMikapen.PanelLayer.Height * gLayerNum

    'Layerクラスのインスタンスを作成する
    gPanelLayer(gLayerNum) = New System.Windows.Forms.Panel
    gPictureBoxLayer(gLayerNum) = New System.Windows.Forms.PictureBox
    gTextBoxLayerName(gLayerNum) = New System.Windows.Forms.TextBox

    'パネルに追加する
    gPanelLayer(gLayerNum).Controls.Add(gTextBoxLayerName(gLayerNum))
    'サイズと位置を設定する
    gTextBoxLayerName(gLayerNum).Location = FrmMikapen.TextBoxLayerName.Location
    gTextBoxLayerName(gLayerNum).Size = FrmMikapen.TextBoxLayerName.Size
    gTextBoxLayerName(gLayerNum).BorderStyle = BorderStyle.None
    gTextBoxLayerName(gLayerNum).BackColor = Color.White
    gTextBoxLayerName(gLayerNum).Text = gLayerNum
    gTextBoxLayerName(gLayerNum).Tag = gLayerNum.ToString
    gTextBoxLayerName(gLayerNum).ReadOnly = True

    'パネルに追加する
    gPanelLayer(gLayerNum).Controls.Add(gPictureBoxLayer(gLayerNum))
    'サイズと位置を設定する
    gPictureBoxLayer(gLayerNum).Location = FrmMikapen.PictureBoxLayer.Location
    gPictureBoxLayer(gLayerNum).Size = FrmMikapen.PictureBoxLayer.Size
    gPictureBoxLayer(gLayerNum).BackgroundImage = FrmMikapen.PictureBoxLayer.BackgroundImage
    gPictureBoxLayer(gLayerNum).BorderStyle = BorderStyle.FixedSingle
    gPictureBoxLayer(gLayerNum).SizeMode = PictureBoxSizeMode.StretchImage
    gPictureBoxLayer(gLayerNum).Tag = gLayerNum.ToString
    gBitmap(gLayerNum) = New Bitmap(FrmMikapen.PictureBoxWork.Width, FrmMikapen.PictureBoxWork.Height)
    gPictureBoxLayer(gLayerNum).Image = gBitmap(gLayerNum)

    'パネルに追加する
    FrmMikapen.PanelFront.Controls.Add(gPanelLayer(gLayerNum))
    'サイズと位置を設定する
    gPanelLayer(gLayerNum).Location = New Point(0, FrmMikapen.PanelFront.Height - FrmMikapen.PanelLayer.Height)
    gPanelLayer(gLayerNum).Size = FrmMikapen.PanelLayer.Size
    gPanelLayer(gLayerNum).BackColor = Color.White
    gPanelLayer(gLayerNum).BorderStyle = BorderStyle.FixedSingle
    gPanelLayer(gLayerNum).Tag = gLayerNum.ToString

    'イベントハンドラーを作成
    AddHandler gTextBoxLayerName(gLayerNum).Click, AddressOf FrmMikapen.mTextBoxLayerName_Click
    AddHandler gTextBoxLayerName(gLayerNum).DoubleClick, AddressOf FrmMikapen.mTextBoxLayerName_DoubleClick
    AddHandler gTextBoxLayerName(gLayerNum).KeyDown, AddressOf FrmMikapen.mTextBoxLayerName_KeyDown
    AddHandler gTextBoxLayerName(gLayerNum).Leave, AddressOf FrmMikapen.mTextBoxLayerName_Leave
    AddHandler gPictureBoxLayer(gLayerNum).Click, AddressOf FrmMikapen.mPictureboxLayer_Click
    AddHandler gPanelLayer(gLayerNum).Click, AddressOf FrmMikapen.mPanelLayer_Click

  End Sub
  '**************************************************
  ' レイヤーの削除
  '**************************************************
  Public Sub LayerDell()
    Dim i As Integer

    If gLayerNum <= 1 Then
      Exit Sub
    End If

    If gSelectLayerNo < gLayerNum Then
      For i = gSelectLayerNo To gLayerNum - 1
        gTextBoxLayerName(i).Text = gTextBoxLayerName(i + 1).Text

        gBitmap(i) = New Bitmap(gBitmap(i + 1)) 'ビットマップをコピーする
        gPictureBoxLayer(i).Image = gBitmap(i)
      Next i
    Else
      '一個前のレイヤーを、選択状態にする
      gSelectLayerNo = gSelectLayerNo - 1
      LayerSelectColor(gSelectLayerNo)
    End If

    'パネルのレイヤーを削除する
    LayerPanelDel(gLayerNum)

    gLayerNum = gLayerNum - 1
    'ベースとなるパネルの高さを設定
    FrmMikapen.PanelFront.Height = FrmMikapen.PanelLayer.Height * gLayerNum

    ReDim Preserve gPanelLayer(gLayerNum)
    ReDim Preserve gPictureBoxLayer(gLayerNum)
    ReDim Preserve gTextBoxLayerName(gLayerNum)
    ReDim Preserve gBitmap(gLayerNum)

  End Sub
  '**************************************************
  ' レイヤーの上移動
  '**************************************************
  Public Sub LayerUp()
    Dim tmpBitmap As Bitmap
    Dim tmpLayerNo As String

    If gSelectLayerNo <= 1 Then
      Exit Sub
    End If

    tmpLayerNo = gTextBoxLayerName(gSelectLayerNo - 1).Text
    tmpBitmap = New Bitmap(gBitmap(gSelectLayerNo - 1)) 'ビットマップをコピーする

    gTextBoxLayerName(gSelectLayerNo - 1).Text = gTextBoxLayerName(gSelectLayerNo).Text
    gBitmap(gSelectLayerNo - 1) = New Bitmap(gBitmap(gSelectLayerNo)) 'ビットマップをコピーする
    gPictureBoxLayer(gSelectLayerNo - 1).Image = gBitmap(gSelectLayerNo - 1)

    gTextBoxLayerName(gSelectLayerNo).Text = tmpLayerNo
    gTextBoxLayerName(gSelectLayerNo).BackColor = Color.White
    gBitmap(gSelectLayerNo) = New Bitmap(tmpBitmap) 'ビットマップをコピーする
    gPictureBoxLayer(gSelectLayerNo).Image = gBitmap(gSelectLayerNo)
    gPanelLayer(gSelectLayerNo).BackColor = Color.White

    If Not IsNothing(tmpBitmap) Then tmpBitmap.Dispose()

    '一個前のレイヤーを、選択状態にする
    gSelectLayerNo = gSelectLayerNo - 1
    LayerSelectColor(gSelectLayerNo)

    tmpBitmap.Dispose()

  End Sub
  '**************************************************
  ' レイヤーの下移動
  '**************************************************
  Public Sub LayerDown()
    Dim tmpBitmap As Bitmap
    Dim tmpLayerNo As String

    If gSelectLayerNo >= gLayerNum Then
      Exit Sub
    End If

    tmpLayerNo = gTextBoxLayerName(gSelectLayerNo + 1).Text
    tmpBitmap = New Bitmap(gBitmap(gSelectLayerNo + 1)) 'ビットマップをコピーする

    gTextBoxLayerName(gSelectLayerNo + 1).Text = gTextBoxLayerName(gSelectLayerNo).Text
    gBitmap(gSelectLayerNo + 1) = New Bitmap(gBitmap(gSelectLayerNo)) 'ビットマップをコピーする
    gPictureBoxLayer(gSelectLayerNo + 1).Image = gBitmap(gSelectLayerNo + 1)

    gTextBoxLayerName(gSelectLayerNo).Text = tmpLayerNo
    gTextBoxLayerName(gSelectLayerNo).BackColor = Color.White
    gBitmap(gSelectLayerNo) = New Bitmap(tmpBitmap) 'ビットマップをコピーする
    gPictureBoxLayer(gSelectLayerNo).Image = gBitmap(gSelectLayerNo)
    gPanelLayer(gSelectLayerNo).BackColor = Color.White

    If Not IsNothing(tmpBitmap) Then tmpBitmap.Dispose()

    '一個後のレイヤーを、選択状態にする
    gSelectLayerNo = gSelectLayerNo + 1
    LayerSelectColor(gSelectLayerNo)

    tmpBitmap.Dispose()

  End Sub
  '**************************************************
  ' 選択されたレイヤーに色を付ける
  '**************************************************
  Public Sub LayerSelectColor(ByVal SelectNo As Integer)

    gPanelLayer(SelectNo).BackColor = Color.Aquamarine
    gTextBoxLayerName(SelectNo).BackColor = Color.Aquamarine

  End Sub
  '**************************************************
  ' レイヤーの情報を取得
  '**************************************************
  Public Sub GetLayerInfo()
    Dim projectFile As System.IO.StreamReader
    Dim mGraphics As Graphics
    Dim ImgAttr As System.Drawing.Imaging.ImageAttributes
    Dim lineData As String
    Dim mFileName As String
    Dim idx As Integer

    ImgAttr = New System.Drawing.Imaging.ImageAttributes()
    ImgAttr.SetColorKey(Color.Transparent, Color.Transparent) '透過色を透過

    Try
      'プロジェクトファイルの読み込み
      projectFile = New System.IO.StreamReader(gProjectSavePath & "\" & gProjectNameEx, System.Text.Encoding.Default)

      lineData = projectFile.ReadLine()
      My.Settings.CanvasWidth = lineData.Substring(lineData.IndexOf(",") + 1) 'キャンバスのXサイズ
      lineData = projectFile.ReadLine()
      My.Settings.CanvasHeight = lineData.Substring(lineData.IndexOf(",") + 1) 'キャンバスのYサイズ

      'ピクチャーボックスの大きさを設定
      PictureBoxSizeSet()

      gLayerNum = 0
      idx = 0
      lineData = projectFile.ReadLine()
      Do Until lineData Is Nothing
        LayerAdd()
        idx = idx + 1
        gPictureBoxLayer(idx).Image = New Bitmap(My.Settings.CanvasWidth, My.Settings.CanvasHeight)
        mGraphics = Graphics.FromImage(gPictureBoxLayer(idx).Image)

        'レイヤーの配列にセット
        mFileName = lineData.Substring(lineData.IndexOf(",") + 1)
        gBitmap(idx) = Image.FromFile(gProjectSavePath & "\" & gProjectName & LAYER_NAME & "\" & mFileName, True) '095 追加
        gBitmap(idx).MakeTransparent(Color.White)
        mGraphics.DrawImage(gBitmap(idx), New Rectangle(New Point(0, 0), gBitmap(idx).Size), 0, 0, gBitmap(idx).Width, gBitmap(idx).Height, GraphicsUnit.Pixel, ImgAttr)
        gTextBoxLayerName(idx).Text = System.IO.Path.GetFileNameWithoutExtension(mFileName)
        gPictureBoxLayer(idx).Invalidate() 'chk

        lineData = projectFile.ReadLine()

        mGraphics.Dispose()
      Loop
      projectFile.Close()
    Catch ex As Exception
      MessageBox.Show("プロジェクトファイルの読み込みに失敗しました", Application.ProductName, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
    End Try

  End Sub
  '**************************************************
  ' レイヤー毎の画像を、ワーク用ピクチャーに合成
  '**************************************************
  Public Sub LayerWorkSet()
    Dim mGraphics As Graphics
    Dim i As Integer

    gGraphicsDraw.Clear(Color.Transparent)
    FrmMikapen.PictureBoxDraw.Invalidate()

    'PictureBoxLayerFrontの設定
    '選択されたレイヤーより、手前にあるレイヤーをまとめる
    mGraphics = Graphics.FromImage(FrmMikapen.PictureBoxLayerFront.Image)
    mGraphics.Clear(Color.Transparent)
    For i = gSelectLayerNo - 1 To 1 Step -1
      mGraphics.DrawImage(gPictureBoxLayer(i).Image, New Rectangle(New Point(0, 0), gBitmap(i).Size), 0, 0, gBitmap(i).Width, gBitmap(i).Height, GraphicsUnit.Pixel)
    Next i
    FrmMikapen.PictureBoxLayerFront.Invalidate()

    'PictureBoxWorkの設定
    '選択されたレイヤー
    mGraphics = Graphics.FromImage(FrmMikapen.PictureBoxWork.Image)
    mGraphics.Clear(Color.Transparent)
    mGraphics.DrawImage(gPictureBoxLayer(gSelectLayerNo).Image, New Rectangle(New Point(0, 0), gBitmap(gSelectLayerNo).Size), 0, 0, gBitmap(gSelectLayerNo).Width, gBitmap(gSelectLayerNo).Height, GraphicsUnit.Pixel)
    FrmMikapen.PictureBoxWork.Invalidate()

    'PictureBoxLayerBackの設定
    '選択されたレイヤーより、後にあるレイヤーをまとめる
    mGraphics = Graphics.FromImage(FrmMikapen.PictureBoxLayerBack.Image)
    mGraphics.Clear(Color.Transparent)
    For i = gLayerNum To gSelectLayerNo + 1 Step -1
      mGraphics.DrawImage(gPictureBoxLayer(i).Image, New Rectangle(New Point(0, 0), gBitmap(i).Size), 0, 0, gBitmap(i).Width, gBitmap(i).Height, GraphicsUnit.Pixel)
    Next i
    FrmMikapen.PictureBoxLayerBack.Invalidate()

    mGraphics.Dispose()

  End Sub
  '**************************************************
  ' 現在開かれているレイーヤの情報を、すべて削除する
  '**************************************************
  Public Sub LayerAllDel()
    Dim i As Integer

    For i = 1 To gLayerNum
      'パネルのレイヤーを削除する
      LayerPanelDel(i)
    Next i

    gLayerNum = 0
    ReDim gPanelLayer(gLayerNum)
    ReDim gPictureBoxLayer(gLayerNum)
    ReDim gTextBoxLayerName(gLayerNum)
    ReDim gBitmap(gLayerNum)

  End Sub
  '**************************************************
  ' パネルのレイヤーを削除する
  '**************************************************
  Public Sub LayerPanelDel(ByVal pos As Integer)

    RemoveHandler gTextBoxLayerName(pos).Click, AddressOf FrmMikapen.mTextBoxLayerName_Click
    RemoveHandler gTextBoxLayerName(pos).DoubleClick, AddressOf FrmMikapen.mTextBoxLayerName_DoubleClick
    RemoveHandler gTextBoxLayerName(pos).KeyDown, AddressOf FrmMikapen.mTextBoxLayerName_KeyDown
    RemoveHandler gTextBoxLayerName(pos).Leave, AddressOf FrmMikapen.mTextBoxLayerName_Leave
    RemoveHandler gPictureBoxLayer(pos).Click, AddressOf FrmMikapen.mPictureboxLayer_Click
    RemoveHandler gPanelLayer(pos).Click, AddressOf FrmMikapen.mPanelLayer_Click

    If Not IsNothing(gPanelLayer(pos)) Then gPanelLayer(pos).Dispose()
    If Not IsNothing(gPictureBoxLayer(pos)) Then gPictureBoxLayer(pos).Dispose()
    If Not IsNothing(gTextBoxLayerName(pos)) Then gTextBoxLayerName(pos).Dispose()
    If Not IsNothing(gBitmap(pos)) Then gBitmap(pos).Dispose()

    '動的に追加したレイヤーを解放する
    FrmMikapen.PanelFront.Controls.Remove(gPanelLayer(pos))
    gPanelLayer(pos).Controls.Remove(gPictureBoxLayer(pos))
    gPanelLayer(pos).Controls.Remove(gTextBoxLayerName(pos))

  End Sub

End Module
